//==============================================================================
// барограф
//==============================================================================

extern "C" 
{ void initTM1637(void);
  void TM1637tislo(unsigned int tislo1,unsigned int tislo2);
  void TM1637time(unsigned char h,unsigned char m,unsigned char s);
  unsigned char TM1637knop(void);
}

extern "C" unsigned char getADC8(unsigned char nomeradc);

extern "C" 
{ void minit(void);
  void mslipping(void);    // режим работы от батареи
}

// датчик давления
#include <SPI.h>
#include <Adafruit_BMP280.h>

#define BMP_SCK  (13)
#define BMP_MISO (12)
#define BMP_MOSI (11)
#define BMP_CS   (10)

//Adafruit_BMP280 bmp(BMP_CS);    // аппаратный SPI
Adafruit_BMP280 bmp(BMP_CS, BMP_MOSI, BMP_MISO,  BMP_SCK); // программный

// дисплей TFT
#include <UTFTGLUE.h>                 // подключение библиотеки
UTFTGLUE myGLCD(0x0154,A2,A1,A3,A4,A0); // подключение дисплея
extern uint8_t SmallFont[]; // шрифт 

// эти функции в модулях tft.ino.  и knopki.ino 
// arduinoIDE НЕ требует их объявления
void initTFT(void);// инициализация дисплея и настройка картинки экрана
void grafik(void);
void mknopki(void);

unsigned char chas = 19, mins = 1, sec = 45;

// режим работы, 1 - питание от сети, 0 - работа от аккумулятора
unsigned char 
  oldregim  = 0,  // предыдущее значение
  regim     = 0;  // текущее значение
   
unsigned char mpress[48]; // массив значений давления

//==============================================================================
void setup()
{
  minit();

  if (!bmp.begin())         // если неудачно
  { TM1637tislo(888,888);
    while (1);              // успешная инициализация
  }
  else TM1637tislo(123,333);

  /* Default settings from datasheet. это взято из примера в библиотеке */
  bmp.setSampling(Adafruit_BMP280::MODE_NORMAL,     /* Operating Mode. */
                  Adafruit_BMP280::SAMPLING_X2,     /* Temp. oversampling */
                  Adafruit_BMP280::SAMPLING_X16,    /* Pressure oversampling */
                  Adafruit_BMP280::FILTER_X16,      /* Filtering. */
                  Adafruit_BMP280::STANDBY_MS_500); /* Standby time. */

// заполняем массив данных начальными данными
  unsigned char i = 0;
  for (i = 0; i < 48; i++)
  { mpress[i] = i;
  }
  mpress[47] = (bmp.readPressure()/133.322) - 720 ;
  grafik();
}
//==============================================================================
// работа с датчиком
void datchik(void)
{ unsigned char i = 0;
  if ((mins ==  2)&&(sec == 0))       // время измерения
  { 
// сдвигаем данные в массиве
    for (i = 1; i < 48; i++)
    { mpress[i-1] = mpress[i];
    }
    mpress[47] = (bmp.readPressure()/133.322) - 720 ;
    delay(100);
    mpress[47] = (bmp.readPressure()/133.322) - 720;
    
    delay(1000);                      // задержка против повторения
  
    if (regim == 1)                   // 1 - питание наличествует
    { grafik();
    }      
  }
}
//==============================================================================
void loop()
{
  datchik();                  // работа с датчиком
//------------------------------ проверим наличие питания
  if (getADC8(5) < 220)       // нет сетевого питания
  { 
    regim = 0;
    mslipping();              // "спящий" режим
  }
  else
  {
    regim = 1;
    if (oldregim == 0)        //  если питание от сети только что включилось
    { initTFT();
      grafik();
    } 
    TM1637time(chas, mins, sec);  // выводит время в формате HH.MM.SS
    mknopki();
  }
  oldregim = regim;
}
//==============================================================================

